package net.pricefx.common.api;

import java.util.Date;


public enum CalculationFlowTimeUnit {
	MINUTE(1), HOUR(60), DAY(60*24);
	
	int minutes;
	
	CalculationFlowTimeUnit(int minutes){
		this.minutes = minutes;
	}
	
	public int getDurationInMinutes(){
		return minutes;
	}

	public Date addToDate(Date date){
		return addToDate(date,1);
	}
	
	public Date addToDate(Date date, int numberOfTimeUnits){
		if (date != null){
			return new Date(date.getTime() + numberOfTimeUnits*60*1000L*minutes);
		}
		return null;
	}
}
