package net.pricefx.formulaengine.optimization;

import java.util.Map;

/**
 * The {@link ModelParallelCalculationFormulaItemContext} is exposed to model parallel calculation logics through the <code>model</code> binding.
 */
public interface ModelParallelCalculationFormulaItemContext extends ModelFormulaContextReadOnly {
    /**
     * @return the item currently calculated
     */
    CalculationItem calculationItem();

    interface CalculationItem {
        /**
         * @return the unique key of this item
         */
        String key();

        /**
         * @return the inputs of this item
         */
        Map<String, Object> inputs();
    }
}
