package net.pricefx.formulaengine.scripting.inputbuilder;

import net.pricefx.common.api.InputType;
import net.pricefx.logic.core.TypeCode;

import java.util.Collection;
import java.util.Optional;

public final class DMSourceInputBuilder extends AbstractInputBuilder<DMSourceInputBuilder, String> {

    public DMSourceInputBuilder(InputBuilderContext builderContext, String paramName) {
        super(builderContext, InputType.DMSOURCE, paramName);
    }

    /**
     * @param typeCodes the source typeCodes
     * @return self
     * @see #setTypes(Collection)
     * @since 9.0 Hurricane
     */
    public DMSourceInputBuilder setTypes(String... typeCodes) {
        return null;
    }

    /**
     * Add the source types to be displayed in the drop down list.
     *
     * @param typeCode the source typeCode
     * @return self
     * @see #setTypes(Collection)
     * @since 9.0 Hurricane
     */
    public DMSourceInputBuilder addType(String typeCode) {
        return null;
    }

    /**
     * Defines the type codes of the sources that will be provided in the drop-down list selector.
     * <p>
     * For example, this will produce a selector providing only DataMarts and DataSources:</br>
     * <pre>
     * def builder = api.inputBuilderFactory().createDMSource("DMSource").setTypes(["DMDS", "DM"])
     * </pre>
     * </p>
     * <p>Available type codes are:</p>
     * <ul>
     *     <li><pre>DM</pre> for DataMarts</li>
     *     <li><pre>DMDS</pre> for DataSources</li>
     *     <li><pre>DMF</pre> for DataFeeds</li>
     *     <li><pre>DMM</pre> for DataMartModels</li>
     *     <li><pre>DMT</pre> for ModelTables</li>
     *     <li><pre>DMSIM</pre> for DataMartSims</li>
     * </ul>
     *
     * @param typeCodes a {@link Collection} of source type codes
     * @return self
     * @since 9.0 Hurricane
     */
    public DMSourceInputBuilder setTypes(Collection<String> typeCodes) {
        return this;
    }

    private boolean validFieldCollectionTypeCode(String typeCode) {
        return true;
    }
}
