package net.pricefx.server.dto.calculation;

import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import net.pricefx.common.api.CalculationResultType;


/**
 * This class is used to transport an array of configurator entries
 */
@JsonIgnoreProperties(ignoreUnknown=true)
public class ConfiguratorEntryArray implements ComplexCalculationResult {

    private static final long serialVersionUID = 3179675501992872676L;
    
    private List<ConfiguratorEntry> entries = new ArrayList<ConfiguratorEntry>();
	
	public ConfiguratorEntryArray() {}
	
	public List<ConfiguratorEntry> getEntries() {
		return entries;
	}
	
	public void setEntries(List<ConfiguratorEntry> entries) {
		this.entries = entries;
	}

	public void addEntry(ConfiguratorEntry e) {
		entries.add(e);
	}
	
	@Override
	public String getResultType() {
		return CalculationResultType.CONFIGURATORENTRYARRAY.name();
	}

}
